import csv
from sys import argv
#
# Example python script to illustrate...
# Convert CSV file to Wireshark display filter format
# copy and paste script output into wireshark display filter
#
# created by Leigh Finch, Wireshark Instructor
# referenced by John Pittle, Instructor for #SFUS23 sessions 8 and 10
#
def dnsshark(file):
    address_list = []
    counter = 0
    display_filter = ""
    try:
        with open(file, newline='') as csvfile:
            csv_reader = csv.DictReader(csvfile, delimiter=',', quotechar='"')
            for row in csv_reader:
                if row['Address'] != "":
                    addr = row['Address'].split(',')
                    hostname = row['Name']
                    for a in addr:
                        if a not in address_list:
                            address_list.append(a)
    except csv.Error as e:
        sys.exit('file {}, line {}: {}'.format(filename, reader.line_num, e))
    for addr in address_list:
        if(counter > 0):
            display_filter += " or "
        display_filter += "ip.addr == " + addr
        counter += 1
    return display_filter

if __name__ == '__main__':
    if len(argv) > 1:
        print(dnsshark(argv[1]))
    else:
        print("Usage: python3 dnsshark.py {filename}")
